<?php

/******************************************************************
*******************************************************************
***	ShuShu Kalender - von 01.01.1970 bis 31.12.2037
***	Basierend auf dem Unix Zeit Stempel / Time Stamp.
***	Erstellt durch Meliantchenkov Pavel am 21.03.2008.
***
***	Programmieraufwand: 4 Stunden
***	Programmiersprachen: PHP, JS, CSS, HTML.
***	(wobei die letzten 2 keine Programmiersprachen sind)
***
***	Script getestet unter: PHP 5.2.3, Apache 2.2.4.
***	Müsste aber auch unter PHP 4.3.0 und höher laufen.
***
***	Dieses Script kann von jedem auf der ShuShu Website
***	runtergeladen, verwendet und beliebig abgeändert werden.
***	Von den Veränderungen ausgeschlossen sind jedoch: 
***	Dieser Kommentar / Kopfzeile und Copyright der im 
***	HTML-Code ausgegeben wird.
***
***	Für weitere Fragen gibt es den ShuB ([Shu]Shu[B]oard)
***	Einfach die Fragen in dem Forum stellen.
***
***	ShuShu Kalender: http://www.shushusrv.de/kalender/
***	ShuShu Server: http://www.shushusrv.de/
***	ShuShu ShuB: http://shub.shushusrv.de/
*******************************************************************
******************************************************************/
	
	function monattage($monat,$jahr,$zeitstempel)
	{
		$array = array();
		
		#echo date("t",$zeitstempel).'<br>'."\r\n";
		
		for($c=1;$c<(date("t",$zeitstempel) + 1);$c++)
		{
			$array[$c] = date("w",mktime(0,0,0,$monat,$c,$jahr));
		}
		
		ksort($array);
		return $array;
	}
	
	function feiertage($jahr)
	{
		$return = array();
		
		//Feste Feiertage
		$return["01"]["01"] = 'Neujahr';
		$return["01"]["06"] = 'Hl. Drei K&ouml;nige';
		$return["05"]["01"] = 'Maifeiertag';
		$return["08"]["15"] = 'Maria Himmelfahrt';
		$return["10"]["03"] = 'Tag der deutschen Einheit';
		$return["10"]["31"] = 'Reformationstag';
		$return["11"]["01"] = 'Allerheiligen';
		$return["12"]["24"] = 'Heiligabend';
		$return["12"]["25"] = 'Erster Weinachtstag';
		$return["12"]["26"] = 'Zweiter Weinachtstag';
		$return["12"]["31"] = 'Sylvester';
		
		
		
		//Bewegliche Feiertage
		$ostern_stamp = ((easter_days($jahr) * 24 * 60 * 60) + mktime(1, 0, 0, 3, 21, $jahr));
		
		$temp = $ostern_stamp - (48*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Rosenmontag';
		$temp = $ostern_stamp - (46*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Aschemittwoch';
		$temp = $ostern_stamp - (2*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Karfreitag';
		$temp = $ostern_stamp;
		$return[date("m",$temp)][date("d",$temp)] = 'Ostersonntag';
		$temp = $ostern_stamp + (1*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Ostermontag';
		$temp = $ostern_stamp + (39*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Christi Himmelfahrt';
		$temp = $ostern_stamp + (49*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Pfingstsonntag';
		$temp = $ostern_stamp + (50*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Pfingstmontag';
		$temp = $ostern_stamp + (39*24*60*60);
		$return[date("m",$temp)][date("d",$temp)] = 'Fronleichnam';
		
		return $return;
	}
	
	$if_get = true;
	$get = explode('/',$_SERVER['REQUEST_URI']);
	list($get_temp) = explode('.',$get[3]);
	$get[3] = $get_temp;
	unset($get_temp);
	
	
	$m_namen_de = array (
							"Januar",
		                    "Februar",
		                    "M&auml;rz",
		                    "April",
		                    "Mai",
		                    "Juni",
		                    "Juli",
		                    "August",
		                    "September",
		                    "Oktober",
		                    "November",
		                    "Dezember"
						);
	
	$m_namen_en = array (
							"January",
		                    "February",
		                    "March",
		                    "April",
		                    "May",
		                    "June",
		                    "July",
		                    "August",
		                    "September",
		                    "October",
		                    "November",
		                    "December"
						);
	
	$get_sort = array	(
							"januar"=>1,
		                    "februar"=>2,
		                    "maerz"=>3,
		                    "april"=>4,
		                    "mai"=>5,
		                    "juni"=>6,
		                    "juli"=>7,
		                    "august"=>8,
		                    "september"=>9,
		                    "oktober"=>10,
		                    "november"=>11,
		                    "dezember"=>12,
							
							"january"=>1,
		                    "february"=>2,
		                    "march"=>3,
		                    "april"=>4,
		                    "may"=>5,
		                    "june"=>6,
		                    "july"=>7,
		                    "august"=>8,
		                    "october"=>10,
							"december"=>12
						);
	
	$int_monat = (!empty($get[3])?intval($get_sort[strtolower($get[3])]):intval($_GET['m']));
	if($int_monat == 0) $int_monat = intval(date("m"));
	
	$jahr = (!empty($get[2])&&intval($get[2])!=0?intval($get[2]):intval($_GET['y']));
	if($jahr == 0 or $jahr > 2037) $jahr = intval(date("Y"));
	
	$zeitstempel = mktime(0,0,0,$int_monat,1,$jahr);
	$monat = monattage($int_monat,$jahr,$zeitstempel);
	$ftage = feiertage($jahr);
	
	$i_monat = $int_monat;
	if($int_monat < 10)
	{
		$int_monat = "0" . $int_monat;
	}
	
	
	$durchlauf = array();
	
	$for = $monat[1];
	if($for == 0)	$for = 7;
	
	for($c=1;$c<$for;$c++)
	{
		$durchlauf[($monat[1] - ($monat[1]-$c))][] = '&nbsp;';
	}
	
	foreach($monat as $k => $w)
	{
		$durchlauf[$w][] = $k;
	}
	
	
	$temp = $durchlauf[0];
	$durchlauf[7] = $temp;
	unset($durchlauf[0]);
	
	$ausgabe = array();
	for($c=0;$c<=6;$c++)
	{
		for($d=1;$d<=(count($durchlauf));$d++)
		{
			$ausgabe[] = ($durchlauf[$d][$c] < 10 && $durchlauf[$d][$c] != '&nbsp;' ? '0':'').$durchlauf[$d][$c];
			
			if($durchlauf[$d][$c] == date("t",$zeitstempel)) break 2;
		}
	}
	
	echo	'	<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
				"http://www.w3.org/TR/html4/loose.dtd">
				<html>
					<head>
						<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
						<meta name="author" content="Meliantchenkov Pavel">
						<meta name="publisher" content="Meliantchenkov Pavel">
						<meta name="copyright" content="Meliantchenkov Pavel">
						<meta name="description" content="ShuShu Kalender (deutsche Feiertage) bis 2037 - PHP.">
						<meta name="keywords" content="kalender,'.$jahr.','.str_ireplace($m_namen_en,$m_namen_de,date("F",$zeitstempel)).','.date("F",$zeitstempel).',feiertag,feiertage,shushu,schuschu,jahreskalender,jahr,monat,tag,kw,woche,php,css,html,source,code,shu,schu,bildung,download,shub,server,der,mysql,programm,script,feiern,ostern,silvester,sylvester,weinachten,merken,wissen,downloaden,sehen">
						<meta name="page-topic" content="Bildung">
						<meta name="audience" content="Alle">
						<meta name="robots" content="index, follow">
						<meta name="revisit-after" content="2days">
						<meta name="verify-v1" content="HbWUyn31OLtqQ3DmqrN8OlVAxKUyyk8GyAgwTGzkVLs=">
						<meta http-equiv="Content-Style-Type" content="text/css">
						<title>ShuShu Kalender - '.str_ireplace($m_namen_en,$m_namen_de,date("F",$zeitstempel)).' / '.date("F",$zeitstempel).' ['.$jahr.']</title>
						<style type="text/css">
							body
							{
								background-color:#f0f0f0;
								font-family: sans-serif,Tahoma;
							}
							.nr_6
							{
								color:red;
							}
							.nr_7
							{
								color:red;
							}
							td
							{
								font-family: sans-serif, Tahoma;
								cursor: default;
							}
							h2
							{
								font-variant:small-caps;
							}
							a
							{
								color:#8b4513;
								font-variant:small-caps;
								text-decoration:none;
								font-size: 14px;
							}
						</style>
					</head>
				<body>
			';
	echo '
			<table width="100%" align="center">
			<tr>
			<td align="center" valign="top" width="15%">
			<br>
		 ';
	
	echo '<a href="'.($if_get ? '?m='.date("n",mktime(0,0,0,$int_monat,1,$jahr)).'&y='.($jahr - 1) : '/'.$get[1].'/'.($jahr - 1).'/'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).'.html').'" title="'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).' - '.($jahr - 1).'" alt="'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).' - '.($jahr - 1).'" onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="background-color:#eaeaea;border:1px solid #000000;font-size:12px;height:19px;vertical-align:middle;width:30px;">&nbsp;<b>&lt;&lt;</b>&nbsp;</a>&nbsp;';
	echo '<select style="border:1px colid #000000;width:70px;height:19px;vertical-align:middle;background-color:#eaeaea;font-weight:bold;" name="y" onchange="location.href=\''.($if_get ? '?m='.date("n",mktime(0,0,0,$int_monat,1,$jahr)).'&y=\' + this.value' : '/'.$get[1].'/\' + this.value + \'/'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).'.html\'').'">'."\r\n";
	for($c=1970;$c<=2037;$c++)
	{
		echo '<option value="'.$c.'"'.($jahr==$c?' selected':'').'>'.$c.'</option>'."\r\n";
	}
	echo '</select>'."\r\n";
	echo '<a href="'.($if_get ? '?m='.date("n",mktime(0,0,0,$int_monat,1,$jahr)).'&y='.($jahr + 1) : '/'.$get[1].'/'.($jahr + 1).'/'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).'.html').'" title="'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).' - '.($jahr + 1).'" title="'.(rand(0,1) ? date("F",mktime(0,0,0,$int_monat,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$int_monat,1,$jahr))))).' - '.($jahr + 1).'" onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="background-color:#eaeaea;border:1px solid #000000;font-size:12px;height:19x;vertical-align:middle;width:30px;">&nbsp;<b>&gt;&gt;</b>&nbsp;</a><br><br><br><br>';
	
	for($c=1;$c<=12;$c++)
	{
		echo '<a onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="display:block;width:130px;background-color:#eaeaea;'.($c==1?'border-top:1px solid #000000;':'').'border-bottom:1px solid #000000;border-left:1px solid #000000;border-right:1px solid #000000;" href="'.($if_get ? '?m='.date("n",mktime(0,0,0,$c,1,$jahr)).'&y='.$jahr : '/'.$get[1].'/'.$jahr.'/'.(rand(0,1) ? date("F",mktime(0,0,0,$c,1,$jahr)):str_ireplace('&auml;','ae',str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$c,1,$jahr))))).'.html').'"><b>'.str_ireplace($m_namen_en,$m_namen_de,date("F",mktime(0,0,0,$c,1,$jahr))).'</b></a>'."\r\n";
	}
	
	echo '<br><br>'."\r\n";
	
	echo '<a onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="display:block;width:130px;background-color:#eaeaea;border-top:1px solid #000000;border-bottom:1px solid #000000;border-left:1px solid #000000;border-right:1px solid #000000;" href="http://www.shushusrv.de/download/shushu_kalender.zip" target="_blank"><b>Download</b></a>'."\r\n";
	echo '<a onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="display:block;width:130px;background-color:#eaeaea;border-bottom:1px solid #000000;border-left:1px solid #000000;border-right:1px solid #000000;" href="http://www.shushusrv.de/" target="_blank"><b>ShuShu Server</b></a>'."\r\n";
	echo '<a onmouseover="'."this.style.backgroundColor='#000000';this.style.color='#ffffff';".'" onmouseout="'."this.style.backgroundColor='#eaeaea';this.style.color='#8b4513';".'" style="display:block;width:130px;background-color:#eaeaea;border-bottom:1px solid #000000;border-left:1px solid #000000;border-right:1px solid #000000;" href="http://shub.shushusrv.de/" target="_blank"><b>ShuShu ShuB</b></a>'."\r\n";
	
	echo '
			</td>
			<td width="85%" align="center" valign="top">
			<table width="100%" align="center">
			<tr><td align="center"><h2><span style="font-size:12px;">['.$jahr.']</span><br>'.str_ireplace($m_namen_en,$m_namen_de,date("F",$zeitstempel)).'</h2></td></tr>
			<tr>
			<td width="85%" align="center" valign="top">
			<table align="center" width="60%">
				<tr>
					<th width="'.(100/8).'%" style="color:#c0c0c0">KW</th>
					<th width="'.(100/8).'%">MO</th>
					<th width="'.(100/8).'%">DI</th>
					<th width="'.(100/8).'%">MI</th>
					<th width="'.(100/8).'%">DO</td>
					<th width="'.(100/8).'%">FR</td>
					<th width="'.(100/8).'%" class="nr_6">SA</th>
					<th width="'.(100/8).'%" class="nr_7">SO</td>
				</tr>
			</table>
		 ';
	
	echo '<table align="center" width="60%" style="border:1px solid #000000;" cellpadding="0" cellspacing="0">'."\r\n";
		$c = 1;
		foreach($ausgabe as $w)
		{
			if($c == 1)
			{
				echo '<tr>'."\r\n";
				echo '<td align="center" width="'.(100/8).'%" height="30" class="w_zahl" style="background-color:#eaeaea;font-size:12px;color:#c0c0c0;border-right:1px solid #000000;"><b>'.date("W",mktime(1,0,0,(intval($w)==0?(intval($int_monat) - 1):intval($int_monat)),(intval($w)==0 ? date("t",mktime(1,0,0,intval($int_monat) - 1,3,$jahr)) : intval($w)),$jahr)).'</b></td>'."\r\n";
			}
			if(isset($ftage[$int_monat][$w]))
			{
				$title = ' title="'.$ftage[$int_monat][$w].'" alt="'.$ftage[$int_monat][$w].'"';
				$style = 'cursor:help;color:red;';
			}
			else
			{
				$title = '';
				$style= '';
			}
			echo '<td align="center" width="'.(100/8).'%" height="30" class="nr_'.$c.'"'.($w!='&nbsp;'?' onmouseover="this.style.backgroundColor=\'#eaeaea\';this.style.fontSize=\'15px\';" onmouseout="this.style.backgroundColor=\'#f0f0f0\';this.style.fontSize=\'12px\';"':'').' style="font-size:12px;'.$style.'"'.$title.'><b>'.$w.'</b></td>'."\r\n";
			if($c == 7)
			{
				$c = 0;
				echo '</tr>'."\r\n";
			}
			$c++;
		}
	echo 	'
				</tr>
				</table>
				</td></tr>
				</table>
				<br>
			';
	
	if(isset($ftage[$int_monat]))
	{
		ksort($ftage[$int_monat]);
		
		echo'
				<table cellspacing="0" cellpadding="0" style="border:1px solid #000000;" width="30%">
					<tr>
						<td style="font-size:14px;border-bottom:1px solid #000000;" align="left"><div style="height:20px;vertical-align:middle;"><b>&nbsp;Feiertage im '.str_ireplace($m_namen_en,$m_namen_de,date("F",$zeitstempel)).' '.$jahr.'</b></div></td>
					</tr>
					<tr>
						<td align="left">
							<b>
			';
		
		foreach($ftage[$int_monat] as $k => $w)
		{
			echo '<div style="height:19px;padding:3px;vertical-align:middle;font-size:10px" onmouseover="this.style.backgroundColor=\'#eaeaea\';this.style.fontSize=\'13px\';this.style.paddingLeft=\'10px;\';" onmouseout="this.style.backgroundColor=\'#f0f0f0\';this.style.fontSize=\'10px\';this.style.paddingLeft=\'3px;\';"><span style="color:red">&nbsp;'.$k.'</span> - '.$w.'</div>'."\r\n";
		}
		
		echo'
							</b>
						</td>
					</tr>
				</table>
			';
	}
	
	echo	'
				</td></tr>
				<tr>
					<td></td><td align="right" style="font-size:12px;color:#bbbbbb;"><br>Copyright &copy; '.(date("Y")=='2008'?'2008':'2008 - '.date("Y")).' by Meliantchenkov Pavel
					
					</td>
				</tr>
				</table>
			</body>
		</html>
			';
	
?>
